/*
Interactions

`Interactions are managed by our flow designer in UI, what you can control via api is how you start and run interaction flow for contact sending events.  Interaction can start in a multiple ways:  - EntryPont - when contact scans QR code ar opens entry point link  - event as trigger - this way you can start flow for single contact  ## Events Events are a data structure related to some contact action. You can use them whenever you want to start active interaction for contact but also inside interaction flow you can define points wher system should wait for custom event sent from your side.   Depending on your use case our predefined interactions might have defined events and instruction what events should be sent.  Events can be sent directly using our REST Api or triggered automatically by our integration modules.  ## Adding attributes to events Adding attributest to event can personalize communication, select branch flow based on attribute value or use them as perameters in other interaction flow actions. Use `body` property in event structure to add key-value attributes. 

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package interactions

import (
	"encoding/json"
)

// checks if the CampaignTriggerConditionsInner type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &CampaignTriggerConditionsInner{}

// CampaignTriggerConditionsInner struct for CampaignTriggerConditionsInner
type CampaignTriggerConditionsInner struct {
	ConditionType string `json:"condition_type"`
	Index float32 `json:"index"`
	Key *string `json:"key,omitempty"`
	Operator string `json:"operator"`
	Values []string `json:"values"`
	ValueType string `json:"value_type"`
}

// NewCampaignTriggerConditionsInner instantiates a new CampaignTriggerConditionsInner object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewCampaignTriggerConditionsInner(conditionType string, index float32, operator string, values []string, valueType string) *CampaignTriggerConditionsInner {
	this := CampaignTriggerConditionsInner{}
	this.ConditionType = conditionType
	this.Index = index
	this.Operator = operator
	this.Values = values
	this.ValueType = valueType
	return &this
}

// NewCampaignTriggerConditionsInnerWithDefaults instantiates a new CampaignTriggerConditionsInner object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewCampaignTriggerConditionsInnerWithDefaults() *CampaignTriggerConditionsInner {
	this := CampaignTriggerConditionsInner{}
	return &this
}

// GetConditionType returns the ConditionType field value
func (o *CampaignTriggerConditionsInner) GetConditionType() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.ConditionType
}

// GetConditionTypeOk returns a tuple with the ConditionType field value
// and a boolean to check if the value has been set.
func (o *CampaignTriggerConditionsInner) GetConditionTypeOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.ConditionType, true
}

// SetConditionType sets field value
func (o *CampaignTriggerConditionsInner) SetConditionType(v string) {
	o.ConditionType = v
}

// GetIndex returns the Index field value
func (o *CampaignTriggerConditionsInner) GetIndex() float32 {
	if o == nil {
		var ret float32
		return ret
	}

	return o.Index
}

// GetIndexOk returns a tuple with the Index field value
// and a boolean to check if the value has been set.
func (o *CampaignTriggerConditionsInner) GetIndexOk() (*float32, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Index, true
}

// SetIndex sets field value
func (o *CampaignTriggerConditionsInner) SetIndex(v float32) {
	o.Index = v
}

// GetKey returns the Key field value if set, zero value otherwise.
func (o *CampaignTriggerConditionsInner) GetKey() string {
	if o == nil || IsNil(o.Key) {
		var ret string
		return ret
	}
	return *o.Key
}

// GetKeyOk returns a tuple with the Key field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *CampaignTriggerConditionsInner) GetKeyOk() (*string, bool) {
	if o == nil || IsNil(o.Key) {
		return nil, false
	}
	return o.Key, true
}

// HasKey returns a boolean if a field has been set.
func (o *CampaignTriggerConditionsInner) HasKey() bool {
	if o != nil && !IsNil(o.Key) {
		return true
	}

	return false
}

// SetKey gets a reference to the given string and assigns it to the Key field.
func (o *CampaignTriggerConditionsInner) SetKey(v string) {
	o.Key = &v
}

// GetOperator returns the Operator field value
func (o *CampaignTriggerConditionsInner) GetOperator() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.Operator
}

// GetOperatorOk returns a tuple with the Operator field value
// and a boolean to check if the value has been set.
func (o *CampaignTriggerConditionsInner) GetOperatorOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Operator, true
}

// SetOperator sets field value
func (o *CampaignTriggerConditionsInner) SetOperator(v string) {
	o.Operator = v
}

// GetValues returns the Values field value
func (o *CampaignTriggerConditionsInner) GetValues() []string {
	if o == nil {
		var ret []string
		return ret
	}

	return o.Values
}

// GetValuesOk returns a tuple with the Values field value
// and a boolean to check if the value has been set.
func (o *CampaignTriggerConditionsInner) GetValuesOk() ([]string, bool) {
	if o == nil {
		return nil, false
	}
	return o.Values, true
}

// SetValues sets field value
func (o *CampaignTriggerConditionsInner) SetValues(v []string) {
	o.Values = v
}

// GetValueType returns the ValueType field value
func (o *CampaignTriggerConditionsInner) GetValueType() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.ValueType
}

// GetValueTypeOk returns a tuple with the ValueType field value
// and a boolean to check if the value has been set.
func (o *CampaignTriggerConditionsInner) GetValueTypeOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.ValueType, true
}

// SetValueType sets field value
func (o *CampaignTriggerConditionsInner) SetValueType(v string) {
	o.ValueType = v
}

func (o CampaignTriggerConditionsInner) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o CampaignTriggerConditionsInner) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	toSerialize["condition_type"] = o.ConditionType
	toSerialize["index"] = o.Index
	if !IsNil(o.Key) {
		toSerialize["key"] = o.Key
	}
	toSerialize["operator"] = o.Operator
	toSerialize["values"] = o.Values
	toSerialize["value_type"] = o.ValueType
	return toSerialize, nil
}

type NullableCampaignTriggerConditionsInner struct {
	value *CampaignTriggerConditionsInner
	isSet bool
}

func (v NullableCampaignTriggerConditionsInner) Get() *CampaignTriggerConditionsInner {
	return v.value
}

func (v *NullableCampaignTriggerConditionsInner) Set(val *CampaignTriggerConditionsInner) {
	v.value = val
	v.isSet = true
}

func (v NullableCampaignTriggerConditionsInner) IsSet() bool {
	return v.isSet
}

func (v *NullableCampaignTriggerConditionsInner) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableCampaignTriggerConditionsInner(val *CampaignTriggerConditionsInner) *NullableCampaignTriggerConditionsInner {
	return &NullableCampaignTriggerConditionsInner{value: val, isSet: true}
}

func (v NullableCampaignTriggerConditionsInner) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableCampaignTriggerConditionsInner) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


